<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" title="Ir a Materiales" v-on:clickEvent="viewListReview" style="margin-bottom:2.5rem"></ReturnButton>
        <el-row :gutter="20">
        <!-- FILTROS DE BUSQUEDA --> 
          <el-col :span="18" class="text-end">
            <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
          </el-col>
          <el-col :span="6">
            <app-search-filter v-model="textSearch"></app-search-filter>
          </el-col>  
      </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <Title :Title="'REVISION DE '+ matType + ' - ESPECIALES'"> </Title>
    </div>

    <!-- Leyenda -->
    <div style="margin:3rem 6rem" v-if="canned == true">
      <div v-if="afiliado == 'true'">
        <el-row>
          <el-col :span="11" :offset="1">
            <h4 style="margin-bottom: 10px">ESPECIALES SIN CAPÍTULOS</h4>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-grey" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Sin Revisar</span>
              </div>
            </el-col>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-green" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Revisión Aprobada</span>
              </div>
            </el-col>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light bg-red" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Pendiente de Reposición</span>
              </div>
            </el-col>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-orange" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Datos incompletos, pero aprobado</span>
              </div>
            </el-col>
          </el-col>
          <el-col :span="10" :offset="2">
            <h4 style="margin-bottom: 10px">ESPECIALES CON CAPÍTULOS</h4>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-grey" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Sin Revisar</span>
              </div>
            </el-col>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-blue" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Aprobado, pero no emitido</span>
              </div>
            </el-col>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-green" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Aprobado y Al aire</span>
              </div>
            </el-col>
            <el-col :span="24" style="margin: 8px 0">
              <div class="flex element-bloq-center" > 
                <div class="border-radius-light l-orange" style="margin-right:1rem; height:25px; width:25px"></div> 
                <span>Aprobado y Emitido</span>
              </div>
            </el-col>
          </el-col>
        </el-row>
      </div>
      <div v-else>
        <DescriptionStateOrders 
          TextSquareGray="Sin Revisar"
          :TextSquarePurple="''" 
          TextSquareGreen="Revisión Aprobada" 
          :TextSquareBlue="''" 
          :TextSquareRed="'Pendiente de Reposición'"  
          :TextSquareOrange="'Datos Incompletos'" :colBoxes="6"/>
      </div>
    </div>
    <div style="margin:3rem 6rem" v-else>
      <DescriptionStateOrders 
        TextSquareGray="Sin Revisar" 
        :TextSquarePurple="''" 
        TextSquareGreen="Aprobado y Al Aire" 
        :TextSquareBlue="'Aprobado, pero no emitido'" 
        :TextSquareRed="''"  
        :TextSquareOrange="'Aprobado y Emitido'" 
        :colBoxes="6"/>
    </div>
    <el-main style="margin:3rem 5rem">
      <el-row>
        <el-col 
          v-for="(material, index) in materials.slice(0,30)"
          :key="index"
          :span="18" :offset="3"
          style="margin-bottom: 4rem;">
          <!-- 3:{subtitle: 'Actores', content: (material.reviewObj)?Array(material.reviewObj.artisticInfo[0].mainActors).join(', '):''}, -->
          <app-card-review 
            :itemPrincipal="material" :rutaImg="require(`../../../assets/images/icono-especiales.svg`)" :shadowBox="'green-shadow'" :imgStyle="'icon-card'" :cannedView="canned" :showRate="canned"
            :detailsData="{
              0:{subtitle: lineDataCardColum1(material, 0).subtitle, content: lineDataCardColum1(material, 0).content},
              1:{subtitle: lineDataCardColum1(material, 1).subtitle, content: lineDataCardColum1(material, 1).content},                              
              2:{subtitle: lineDataCardColum1(material, 2).subtitle, content: lineDataCardColum1(material, 2).content},
              3:{subtitle: lineDataCardColum1(material, 3).subtitle, content: lineDataCardColum1(material, 3).content},
            }"
            :detailsData2="{
              0:{subtitle: lineDataCardColum2(material, 0).subtitle, content: lineDataCardColum2(material, 0).content},
              1:{subtitle: lineDataCardColum2(material, 1).subtitle, content: lineDataCardColum2(material, 1).content},
              2:{subtitle: lineDataCardColum2(material, 2).subtitle, content: lineDataCardColum2(material, 2).content},
              3:{subtitle: lineDataCardColum2(material, 3).subtitle, content: lineDataCardColum2(material, 3).content},
            }"
            :btnGroup="{
              0:{validationBtnShow: material.reviewStatus === 'withoutChecking', btnClass: 'b-grey t-grey', btnTextAction: 'SIN REVISAR', editVal: 'selectedMaterial', newVal: (canned == true)?((afiliado == 'true')?((material.numChapters.length>0)?'revNovel':'revision'):'revision'):(material.numChapters.length>0)?'revFusionGourmet':'revisionNacional'},  
              1:{validationBtnShow: (material.reviewStatus === 'approved') || (material.reviewStatus === 'live'), btnClass: 'b-green t-green', btnTextAction: (canned == true)?'APROBADO':'AL AIRE', editVal: 'selectedMaterial', newVal: (canned == true)?((afiliado == 'true')?((material.numChapters.length>0)?'revNovelDoc':'report'):'report'):'reporteNacional'},
              2:{validationBtnShow: material.reviewStatus === 'pending', btnClass: 'border-red text-red', btnTextAction: 'PENDIENTE', editVal: 'selectedMaterial', newVal: (afiliado == 'true')?((material.numChapters.length>0)?'revNovelDoc':'report'):'report'},
              3:{validationBtnShow: (material.reviewStatus === 'incomplete') || (material.reviewStatus === 'transmitted'), btnClass: 'b-orange t-orange', btnTextAction: (canned == true)?'INCOMPLETO':'EMITIDO', editVal: 'selectedMaterial', newVal: (canned == true)?((afiliado == 'true')?((material.numChapters.length>0)?'revNovelDoc':'report'):'report'):'reporteNacional'},
              4:{validationBtnShow: material.reviewStatus === 'approved2', btnClass: 'b-blue t-blue', btnTextAction: 'NO EMITIDO', editVal: 'selectedMaterial', newVal: (canned == true)?((afiliado == 'true')?((material.numChapters.length>0)?'revNovelDoc':'report'):'report'):'reporteNacional'},
            }">
          </app-card-review>

        </el-col>
      </el-row>
    </el-main>
  </div>
</template>

<script>
// @ is an alias to /src
import router from 'vue-router'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '../../../utils/modifyText.js'
import CardReview from '@/components/cardReview'
import Title from '@/components/Title.vue' 
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue'
import { HTTP } from '../../../main.js' 

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    'app-card-review': CardReview,
    DescriptionStateOrders,
    Title,
  },
  data () {
    return {
      canned: false,
      returnButtonModal: false,
      filterSelect: '',
      textSearch: '',
      allFilters: [
        {value: 'providerName', label: 'Proveedor'},
        {value: 'codMaterial', label: 'Código de Material'}
      ],
      typeMaterialR: localStorage.getItem('typeMaterialR'),
      afiliado: localStorage.getItem('afiliado'),
      arrMaterial: [],
      arrMaterialNacional: [],
      arrAffiliate: [],
      arrAffiliateTelevisa: [],
      matType: localStorage.getItem('classification')
    }
  },
  created () {
    this.canned = this.$route.params.canned
    if(this.afiliado == 'true') {
      this.getMaterialsDeAfiliado('TELEVISA - ESPECIALES', 'arrAffiliateTelevisa')
      this.getMaterialsDeAfiliado('Programas Especiales', 'arrAffiliate')
    } else {
      
      if(this.canned){
        this.getMaterialCanned(this.typeMaterialR, 'arrMaterial')
      } else{
        this.getMaterial('Especial', 'arrMaterialNacional')
      }
    }
  },
  computed: {
    materials () {
      let specials

      if(this.afiliado == 'true'){
        specials = this.arrAffiliateTelevisa.concat(this.arrAffiliate)
      } else {
        if(this.canned) {
          specials = this.arrMaterial
        } else {
          specials = this.arrMaterialNacional
        }
      }
     
      if (this.textSearch) {
        specials = specials.filter(
          m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1) ||
                modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
      }

      if (this.filterSelect && this.textSearch) {
        specials = specials.filter(
          m => modifyText(m[this.filterSelect]).indexOf(modifyText(this.textSearch)) !== -1)
      }
      // specials.sort(function(a, b){
      //   console.log(a,'a')
      //   console.log(b,'b')
      //   return b.geminisCode - a.geminisCode
      // })

      return specials
    }
  },
  methods: {
    orderDataByGeminisCode (array) {
      
      array.sort(function (a, b) {
        if ( Number(a.geminisCode) < Number(b.geminisCode) ) {
          return 1;
        }
        if ( Number(a.geminisCode) > Number(b.geminisCode )) {
          return -1;
        }
        return 0;
      });
      return array
    },
    
    lineDataCardColum2(material, position) {
      let dataCard = {subtitle:'',content:''}
      switch(position) {
        case 0:
          if ( this.afiliado == 'true' ) {
            if( material.numChapters.length > 0 ) {
              dataCard.subtitle = 'Temporadas';
              dataCard.content = (material.numChapters.map(i => i.season)).join(' - ');;
            }
            else {
              dataCard.subtitle = 'Género';
              dataCard.content = (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:'';
            }
          }
          else {
            if ( this.canned == true ) {//Si es enlatado
              dataCard.subtitle = 'Género';
              dataCard.content = (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:'';
            }
            else {//Es nacional
              if ( material.numChapters.length > 0 ) {
                dataCard.subtitle = 'Género';
                dataCard.content = material.genre;
              }
              else {
                dataCard.subtitle = 'Clasificación';
                dataCard.content = material.classification
              }
            }
          }
          break;
        case 1:
          if ( this.afiliado == 'true' ) {
            if( material.numChapters.length > 0 ) {
              dataCard.subtitle = 'Género';
              dataCard.content = (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:'';
            }
            else {
              dataCard.subtitle = 'Género';
              dataCard.content = (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:'';
            }
          }
          else {
            if ( this.canned == true ) {//Si es enlatado
              dataCard.subtitle = 'Clasificación';
              dataCard.content = (material.reviewObj)?material.reviewObj.classification:'';
            }
            else {//Es nacional
              if ( material.numChapters.length > 0 ) {
                dataCard.subtitle = 'Clasificación';
                dataCard.content = material.classification
              }
              else {
                dataCard.subtitle = 'Etiquetas';
                dataCard.content = (material.reviewObj)?Array(Object(material.reviewObj).dynamicTags).join(', '):'';                
              }
            }
          }
          break;
        case 2:
          if ( this.afiliado == 'true' ) {
            if( material.numChapters.length > 0 ) {
              dataCard.subtitle = 'Clasificación';
              dataCard.content = (material.reviewObj)?(material.reviewObj.classification):'';
            }
            else {
              dataCard.subtitle = 'Etiquetas';
              dataCard.content = (material.reviewObj)?Array(Object(material.reviewObj).dynamicTags).join(', '):''; 
            }
          }
          else {
            if ( this.canned == true ) {//Si es enlatado
              dataCard.subtitle = 'Etiquetas';
              dataCard.content = (material.reviewObj)?Array(Object(material.reviewObj).dynamicTags).join(', '):'';
            }
            else {//Es nacional
              if ( material.numChapters.length > 0 ) {
                dataCard.subtitle = '';
                dataCard.content = ''
              }
              else {
                dataCard.subtitle = '';
                dataCard.content = '';                
              }
            }
          }
        break;
        case 3:
          if ( this.afiliado == 'true' ) {
            if( material.numChapters.length > 0 ) {
              console.log('holas')
              dataCard.subtitle = 'Actores';
              dataCard.content = (material.reviewObj)?Array(material.reviewObj.artisticInfo[0].mainActors).join(', '):'';
            }
            else {
              console.log('holas1')
              dataCard.subtitle = 'Actores';
              dataCard.content = (material.reviewObj)?Array(material.reviewObj.artisticInfo[0].mainActors).join(', '):''; 
            }
          }
          else {
            
            if ( this.canned == true ) {//Si es enlatado
              dataCard.subtitle = 'Conductores';
              dataCard.content = (material.reviewObj == undefined ) ? ''  : Array(material.reviewObj.artisticInfo).length == 1  ? '' :  Array(material.reviewObj.artisticInfo[0].mainActors).join(', ');
            }
            else {//Es nacional
              if ( material.numChapters.length > 0 ) {
                dataCard.subtitle = '';
                dataCard.content = ''
              }
              else {
                dataCard.subtitle = '';
                dataCard.content = '';                
              }
            }
          }
        break;
      }
      return dataCard
    },
    lineDataCardColum1(material, position) {
      let dataCard = {subtitle:'',content:''}
      switch(position) {
        case 0:
          dataCard.subtitle = 'Código de Material';
          dataCard.content = material.codMaterial;
          break;
        case 1:
          dataCard.subtitle = 'Proveedor';
          dataCard.content = material.providerName;
          break;
        case 2:
          if ( this.afiliado == true ) {
            if( material.numChapters.length > 0 ) {
              dataCard.subtitle = 'Cod. Proveedor';
              dataCard.content = material.providerCode;
            }
            else {
              dataCard.subtitle = 'Cod. Proveedor';
              dataCard.content = material.providerCode;
            }
          }
          else {
            if ( this.canned == true ) {//Si es enlatado
              dataCard.subtitle = 'Cod. Proveedor';
              dataCard.content = material.providerCode;
            }
            else {//Es nacional
              if ( material.numChapters.length > 0 ) {
                dataCard.subtitle = 'Temporada';
                dataCard.content = (material.numChapters.map(i => i.season)).join(' - ');
              }
              else {
                dataCard.subtitle = 'Género';
                dataCard.content = material.genre;
              }
            }
          }
          break;
        case 3:
          if ( this.afiliado == true ) {
            if( material.numChapters.length > 0 ) {
              dataCard.subtitle = 'Cod. Contrato';
              dataCard.content = material.contractCode;
            }
            else {
              dataCard.subtitle = 'Cod. Contrato';
              dataCard.content = material.contractCode;
            }
          }
          else {
            if ( this.canned == true ) {//Si es enlatado
              dataCard.subtitle = 'Cod. Contrato';
              dataCard.content = material.contractCode;
            }
            else {//Es nacional
              if ( material.numChapters.length > 0 ) {
                dataCard.subtitle = '';
                dataCard.content = '';
              }
              else {
                dataCard.subtitle = '';
                dataCard.content = '';
              }
            }
          }
          break;
      }
      return dataCard
    },
    getMaterialCanned(material, arr) {
      console.log('hellou 22')
      
      // HTTP.get('materials/materialType/'+material+'/providerName')
      //   .then(res => {
          this[arr] =  this.orderDataByGeminisCode(this.$store.state[this.typeMaterialR]) 
      //   })
      //   .catch(err => {
      //     console.log(err);
      //   });
    },
    getMaterial(material, arr) {
      HTTP.get('materials/materialType/'+material+'/canned/false')
        .then(res => {
          this[arr] = this.orderDataByGeminisCode (res.data.materials)
        })
        .catch(err => {
          console.log(err);
        });
    },
    getMaterialsDeAfiliado (material, arr) {
      HTTP.get('materials/materialType/' + material + '/canned/true')
      .then(res => {
        let totalMat = this.orderDataByGeminisCode (res.data.materials)       
        totalMat.map(el => {
          if(el.materialType[1] == 'Televisa'){
            this[arr].push(el)
          }
        })
      })
      .catch(err => console.log(err))
    },
    viewListReview () {
      if(this.afiliado == 'true'){
        this.$router.push({name: 'revAfiliadoTelevisa'})
      } else {
        if(this.canned){
          this.$router.push({name: 'materialesEnlatados', params: { canned: true } })
        } else{
          this.$router.push({name: 'produccionNacional', params: { canned: false } })
        }
      }
      
    }
  }
}
</script>

<style>
.green-shadow{
  box-shadow: 5px 5px 10px #4cc35b8c  !important;
}
</style>
